/*
 * The Emerald Distributed Programming Language
 * 
 * Copyright (C) 2004 Emerald Authors & Contributors
 * 
 * This file is part of the Emerald Distributed Programming Language.
 *
 * The Emerald Distributed Programming Language is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; version 2 of the License.
 *
 *  The Emerald Distributed Programming Language is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with the Emerald Distributed Programming Language; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * 
 */

#define LDI 0
#define LDIR 1
#define LDL 2
#define LDO 3
#define LDA 4
#define NCCALL 5
#define STL 6
#define STO 7
#define STA 8
#define LDVL 9
#define LDVO 10
#define LDVA 11
#define STVL 12
#define STVO 13
#define STVA 14
#define LDIS 15
#define FPOW 16
#define LDLS 17
#define LDOS 18
#define LDAS 19
#define STLS 20
#define STOS 21
#define STAS 22
#define LDVLS 23
#define LDVOS 24
#define LDVAS 25
#define STVLS 26
#define STVOS 27
#define STVAS 28
#define LDIB 29
#define ISTRX 30
#define LDLB 31
#define LDOB 32
#define LDAB 33
#define STLB 34
#define STOB 35
#define STAB 36
#define LDVLB 37
#define LDVOB 38
#define LDVAB 39
#define STVLB 40
#define STVOB 41
#define STVAB 42
#define DUP 43
#define DUPV 44
#define SWAP 45
#define ADD 46
#define SUB 47
#define MUL 48
#define DIV 49
#define MOD 50
#define NEG 51
#define FADD 52
#define FSUB 53
#define FMUL 54
#define FDIV 55
#define FNEG 56
#define EQ 57
#define NE 58
#define GT 59
#define GE 60
#define LT 61
#define LE 62
#define FCMP 63
#define SCMP 64
#define AND 65
#define OR 66
#define NOT 67
#define ASSERT 68
#define CSTR 69
#define FINT 70
#define IFLO 71
#define ISTR 72
#define FSTR 73
#define EBSTR 74
#define BGETS 75
#define BGETU 76
#define BSET 77
#define NTOH 78
#define GETB 79
#define GET 80
#define GETV 81
#define SET 82
#define SETV 83
#define GSLICE 84
#define SETLOCSRV 85
#define CAT 86
#define LEN 87
#define SETDEBUGGER 88
#define CALLOID 89
#define LINK 90
#define LINKB 91
#define RET 92
#define QUIT 93
#define GETLOCSRV 94
#define CREATE 95
#define CREATEVEC 96
#define QUITP 97
#define BR 98
#define BRT 99
#define BRF 100
#define CASE 101
#define TRAPF 102
#define RETFAIL 103
#define LDSELF 104
#define LDSELFV 105
#define PUSHNIL 106
#define PUSHNILV 107
#define POOP 108
#define SYS 109
#define GETENV 110
#define SETENV 111
#define STRI 112
#define CREATEVECLIT 113
#define STRHASH 114
#define BREAKME 115
#define FORWARD 116
#define BREAKPT 117
#define UPB 118
#define STRLIT 119
#define LDINDS 120
#define LDVINDS 121
#define PUSHCT 122
#define STRF 123
#define XCREATE 124
#define XSYS 125
#define MONINIT 126
#define MONENTER 127
#define MONEXIT 128
#define CONDINIT 129
#define CONDWAIT 130
#define CONDSIGNAL 131
#define CONDAWAITING 132
#define DOLITERALS 133
#define INSTALLINOID 134
#define GETROOTDIR 135
#define CHECKPOINT 136
#define BXSYS 137
#define GCOLLECT 138
#define LAND 139
#define LOR 140
#define LSETBIT 141
#define LGETBIT 142
#define CALCSIZE 143
#define IABS 144
#define CALLOIDS 145
#define CALLSTAR 146
#define CALLSTARCLEAN 147
#define CONFORMS 148
#define DSTR 149
#define DLOAD 150
#define RELOCATEVECTOR 151
#define RELOCATETYPE 152
#define STUBCALL 153
#define STUBRETURN 154
#define GETOID 155
#define TESTREMOTE 156
#define GETIDSEQ 157
#define CCALL 158
#define LDLITB 159
#define SWAPV 160
#define DOCTLITERALS 161
#define CVX 162
#define TESTREMOTE2 163
#define CODEOF 164
#define BUILDABCON 165
#define CHECKARGABCONB 166
#define CALLS 167
#define CALLCTB 168
#define CONDSIGNALANDEXIT 169
#define LSETBITS 170
#define LGETBITS 171
#define VIEW 172
#define CALLER 173
#define INDIR 174
#define INDIRV 175
#define GETISTATE 176
#define STRTOK 177
#define ADJSP 178
#define LSECS 179
#define CREATEGAGGLE 180
#define ADDTOGAGGLE 181
#define GETGAGGLEMEMBER 182
#define GETGAGGLEELEMENT 183
#define GETGAGGLESIZE 184
